require "uri"
require 'openssl'
require "base64"

module AliSms

  module Util

    def self.make_query_str(dataHash)
      sortHash = Hash[dataHash.sort_by { |k, v| k }]
      if sortHash.has_key?("sign")
        sortHash.delete("sign")
      end

      sortQueryStr = ""
      sortHash.each do |k, v|
        sortQueryStr = sortQueryStr + "&" + specialUrlEncode(k) + "=" + specialUrlEncode(v)
      end
      sortQueryStr = sortQueryStr[1..-1]

      return sortQueryStr
    end

    def self.make_sign(sortQueryStr, httpMethod, key)
      str = httpMethod + "&" + specialUrlEncode("/") + "&" + specialUrlEncode(sortQueryStr)

      digest = OpenSSL::Digest.new("sha1")
      str_8 = str.encode("UTF-8")
      hash  = OpenSSL::HMAC.digest(digest, key, str_8)
      base64_str = Base64.encode64(hash).chomp
      
      sign = specialUrlEncode(base64_str)

      return sign
    end

    # 此方法没有问题
    def self.specialUrlEncode(value)
      str = CGI.escape(value)
      return str.gsub("+", "%20").gsub("*", "%2A").gsub("%7E", "~")
    end

  end
end